# 域名解析的相关方法

>域名解析是把域名指向网站空间IP，让人们通过注册的域名可以方便地访问到网站的一种服务。IP地址是网络上标识站点的数字地址，为了方便记忆，采用域名来代替IP地址标识站点地址。域名解析就是域名到IP地址的转换过程。域名的解析工作由DNS服务器完成。
域名解析也叫域名指向、服务器设置、域名配置以及反向IP登记等等。说得简单点就是将好记的域名解析成IP，服务由DNS服务器完成，是把域名解析到一个IP地址，然后在此IP地址的主机上将一个子目录与域名绑定。

## 常用域名解析种类和方法

* 假如我们已经注册好一个域名是`hyperapp.fun`,下文以此为例。

### A 解析

A 解析是地址解析的意思，把一个域名指向一个IP地址，达到访问域名即是访问IP地址的效果，在HyperApp中绝大部分的网站类应用(包含但不限于博客，论坛，网盘等)和一部分代理应用(包含但不限于V2ray，nghttpx等)使用A类解析即可。

```
1. 找到域名服务商的 DNS 管理页面
2. 新建一个记录
3. 主机名选择想要的主机名，假如填写 aaa，则此记录影响到的域名是`aaa.hypreapp.fun`。假如想要直接操作 hyperapp.fun 则主机名填"@"
4. 记录类型，选择A记录
5. 地址填写你的IP地址
```

其他内容不变，点击保存即可，等待片刻即可解析成功。

- 成功的标志是`ping`域名时返回你的IP地址

### CNAME 解析

CNAME 解析是别名解析的意思。如果需要将域名指向另一个域名，再由另一个域名提供IP地址，就需要添加CNAME记录。HyperApp中的“爱国套装”中可能需要许多个子域名指向同一个IP地址，这种情况下可以使用别名解析。

假如想要设置4个域名 (one.hyperapp.fun; two.hyperapp.fun; three.hyperapp.fun; four.hyperapp.fun) 分别解析到同一个IP地址,步骤如下

```
1. 首先新建一个记录，将 one.hyperapp.fun A解析到IP地址，方法见上
2. 再新建一个记录，主机名填写 two
3. 记录类型，选择CNAME记录.
4. 地址填写 one.hyperapp.fun
5. 重复2-4的步骤添加剩下的域名
```

点击保存即可，等待片刻即可解析成功，如果以后更换了IP地址，只需要更改 one.hyperapp.fun 的A 解析记录即可，其他CNAME到 one.hyperapp.fun的所有域名都会自动解析到新的IP地址，十分方便。

- 成功的标志是`ping`以上4个域名均返回相同的IP地址

### 其他解析方式

其他诸如：MX,TXT,SRV,AAAA等稍微不常用的解析方式不做赘述。
